# sutty-migration

## Installation

Add this line to your site's Gemfile:

```ruby
gem 'sutty-migration'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install sutty-migration

## Usage

Add the plugin to your `_config.yml`:

```yaml
plugins:
- sutty-migration
```

Compile a CSV file with the following required fields:

```
id,title,date
```

The `date` field is optional, but once they're set they can't change,
otherwise you'll start to find duplicates.

Put the CSV file inside a `_data/migration/` directory and name it as
the layout you're migrating into.  For instance, to migrate posts, use
a file called `_data/migration/post.csv`.

Then, define the layout data by using a layout data file.  You can
create one of these using `sutty-cli`.

```bash
# install sutty-cli
gem install sutty-cli
# create a layout
sutty-cli layout post
# add fields
sutty-cli field description --layout post --type text
```

And now you can add the `description` field into the CSV:

```
id,title,date,description
1,"Article",2020-01-01,"Short description"
```

The ID is important to identify updates, it can be anything, numbers,
letters, etc.  We recommend using unique identifiers like UUIDs.

To start migration just build your site:

```bash
bundle exec jekyll build
```

## Contributing

Bug reports and pull requests are welcome on 0xacab.org at
<https://0xacab.org/sutty/jekyll/sutty-migration>. This
project is intended to be a safe, welcoming space for collaboration, and
contributors are expected to adhere to the [Sutty code of
conduct](https://sutty.nl/en/code-of-conduct/).

If you like our plugins, [please consider
donating](https://donaciones.sutty.nl/en/)!

## License

The gem is available as free software under the terms of the GPL3
License.

## Code of Conduct

Everyone interacting in the sutty-migration project’s codebases, issue
trackers, chat rooms and mailing lists is expected to follow the [code
of conduct](https://sutty.nl/en/code-of-conduct/).
